> ## Documentation Index
> Fetch the complete documentation index at: https://docs.withorb.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Fetch customer by external ID

> This endpoint is used to fetch customer details given an `external_customer_id` (see
[Customer ID Aliases](/events-and-metrics/customer-aliases)).

Note that the resource and semantics of this endpoint exactly mirror [Get Customer](fetch-customer).



## OpenAPI

````yaml /api-reference/orb-openapi.json get /customers/external_customer_id/{external_customer_id}
openapi: 3.1.0
info:
  title: API Reference
  description: >-
    Orb's API is built with the following principles in mind:


    1. **Predictable developer experience**: Where applicable, the Orb API uses
    industry-standard patterns such as

    cursor-based pagination and standardized error output. To help with
    debugging in critical API

    actions, the API always strives to provide detailed and actionable error
    messages. Aliases

    such as external customer IDs aid in fast integration times.

    2. **Reliably real time**: Orb's event-based APIs, such as event ingestion
    are designed to handle extremely high

    throughput and scale with concurrent load. Orb also provides a real-time
    event-level credits

    ledger and a highly performant webhooks architecture.

    3. **Flexibility at the forefront**: Features like timezone localization and
    the ability to amend historical usage

    show the flexible nature of the platform.


    You can download the latest OpenAPI spec
    [here](https://api.withorb.com/spec.json) - pass `?version=3.0` for an

    OpenAPI 3.0-compatible spec.
  contact:
    name: Orb, Inc.
    url: https://www.withorb.com/
    email: team@withorb.com
  version: '1.0'
servers:
  - url: https://api.withorb.com/v1
    description: Production server
security:
  - APIKeyAuth: []
tags:
  - name: Alert
    description: >-
      [Alerts within Orb](/product-catalog/configuring-alerts) monitor spending,

      usage, or credit balance and trigger webhooks when a threshold is
      exceeded.


      Alerts created through the API can be scoped to either customers or
      subscriptions.
  - name: Availability
  - name: Coupon
    description: >-
      A coupon represents a reusable discount configuration that can be applied
      either as a fixed or percentage amount to an invoice or subscription.
      Coupons are activated using a redemption code, which applies the discount
      to a subscription or invoice. The duration of a coupon determines how long
      it remains available for use by end users.
  - name: Credit
    description: >-
      The [Credit Ledger Entry resource](/product-catalog/prepurchase) models
      prepaid credits within Orb.
  - name: Credit note
    description: >-
      The [Credit Note](/invoicing/credit-notes) resource represents a credit
      that has been applied to a

      particular invoice.
  - name: Customer
    description: >-
      A customer is a buyer of your products, and the other party to the billing
      relationship.


      In Orb, customers are assigned system generated identifiers automatically,
      but it's often desirable to have these

      match existing identifiers in your system. To avoid having to denormalize
      Orb ID information, you can pass in an

      `external_customer_id` with your own identifier. See

      [Customer ID Aliases](/events-and-metrics/customer-aliases) for further
      information about how these

      aliases work in Orb.


      In addition to having an identifier in your system, a customer may exist
      in a payment provider solution like

      Stripe. Use the `payment_provider_id` and the `payment_provider` enum
      field to express this mapping.


      A customer also has a timezone (from the standard [IANA timezone
      database](https://www.iana.org/time-zones)), which

      defaults to your account's timezone. See [Timezone
      localization](/essentials/timezones) for

      information on what this timezone parameter influences within Orb.
  - name: Dimensional Price Group
  - name: Event
    description: >-
      The [Event](/core-concepts#event) resource represents a usage event that
      has been created for a

      customer. Events are the core of Orb's usage-based billing model, and are
      used to calculate the usage charges for

      a given billing period.
  - name: Invoice
    description: >-
      An [`Invoice`](/core-concepts#invoice) is a fundamental billing entity,
      representing the request for payment for

      a single subscription. This includes a set of line items, which correspond
      to prices in the subscription's plan and

      can represent fixed recurring fees or usage-based fees. They are generated
      at the end of a billing period, or as

      the result of an action, such as a cancellation.
  - name: Item
    description: >-
      The Item resource represents a sellable product or good. Items are
      associated with all line items, billable metrics,

      and prices and are used for defining external sync behavior for invoices
      and tax calculation purposes.
  - name: License
  - name: LicenseType
    description: >-
      The LicenseType resource represents a type of license that can be assigned
      to users.

      License types are used during billing by grouping metrics on the
      configured grouping key.
  - name: Metric
    description: >-
      The Metric resource represents a calculation of a quantity based on
      events.

      Metrics are defined by the query that transforms raw usage events into
      meaningful values for your customers.
  - name: Plan
    description: >-
      The [Plan](/core-concepts#plan-and-price) resource represents a plan that
      can be subscribed to by a

      customer. Plans define the billing behavior of the subscription. You can
      see more about how to configure prices

      in the [Price resource](/reference/price).
  - name: Price
    description: >-
      The Price resource represents a price that can be billed on a
      subscription, resulting in a charge on an invoice in

      the form of an invoice line item. Prices take a quantity and determine an
      amount to bill.


      Orb supports a few different pricing models out of the box. Each of these
      models is serialized differently in a

      given Price object. The model_type field determines the key for the
      configuration object that is present.


      For more on the types of prices, see [the core concepts
      documentation](/core-concepts#plan-and-price)
  - name: Price interval
    description: >-
      The Price Interval resource represents a period of time for which a price
      will bill on a subscription. A

      subscription’s price intervals define its billing behavior.
  - name: Subscription
    description: >-
      A [subscription](/core-concepts#subscription) represents the purchase of a
      plan by a customer.


      By default, subscriptions begin on the day that they're created and renew
      automatically for each billing cycle at

      the cadence that's configured in the plan definition.


      Subscriptions also default to **beginning of month alignment**, which
      means the first invoice issued for the

      subscription will have pro-rated charges between the `start_date` and the
      first of the following month. Subsequent

      billing periods will always start and end on a month boundary (e.g.
      subsequent month starts for monthly billing).


      Depending on the plan configuration, any _flat_ recurring fees will be
      billed either at the beginning (in-advance)

      or end (in-arrears) of each billing cycle. Plans default to **in-advance
      billing**. Usage-based fees are billed in

      arrears as usage is accumulated. In the normal course of events, you can
      expect an invoice to contain usage-based

      charges for the previous period, and a recurring fee for the following
      period.
  - name: Subscription Change
paths:
  /customers/external_customer_id/{external_customer_id}:
    get:
      tags:
        - Customer
      summary: Fetch customer by external ID
      description: >-
        This endpoint is used to fetch customer details given an
        `external_customer_id` (see

        [Customer ID Aliases](/events-and-metrics/customer-aliases)).


        Note that the resource and semantics of this endpoint exactly mirror
        [Get Customer](fetch-customer).
      operationId: fetch-customer-external-id
      parameters:
        - required: true
          style: simple
          schema:
            type: string
          name: external_customer_id
          in: path
      responses:
        '200':
          description: OK
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Customer'
        '400':
          description: Bad Request
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/400Error'
        '401':
          description: Unauthorized
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/401Error'
        '404':
          description: Not Found
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/404Error'
        '409':
          description: Conflict
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/409Error'
        '413':
          description: Content Too Large
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/413Error'
        '429':
          description: Too Many Requests
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/429Error'
        '500':
          description: Internal Server Error
          headers: {}
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/500Error'
components:
  schemas:
    Customer:
      properties:
        metadata:
          additionalProperties:
            type: string
          type: object
          title: Metadata
          description: >-
            User specified key-value pairs for the resource. If not present,
            this defaults to an empty dictionary. Individual keys can be removed
            by setting the value to `null`, and the entire metadata mapping can
            be cleared by setting `metadata` to `null`.
        id:
          type: string
          title: Id
        external_customer_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Customer Id
          description: >-
            An optional user-defined ID for this customer resource, used
            throughout the system as an alias for this Customer. Use this field
            to identify a customer by an existing identifier in your system.
        name:
          type: string
          title: Name
          description: The full name of the customer
        email:
          type: string
          title: Email
          description: >-
            A valid customer email, to be used for notifications. When Orb
            triggers payment through a payment gateway, this email will be used
            for any automatically issued receipts.
        timezone:
          type: string
          title: Timezone
          description: >-
            A timezone identifier from the IANA timezone database, such as
            "America/Los_Angeles". This "defaults to your account's timezone if
            not set. This cannot be changed after customer creation.
        payment_provider_id:
          oneOf:
            - type: string
            - type: 'null'
          title: Payment Provider Id
          description: >-
            The ID of this customer in an external payments solution, such as
            Stripe. This is used for creating charges or invoices in the
            external system via Orb.
        payment_provider:
          oneOf:
            - type: string
              enum:
                - quickbooks
                - bill.com
                - stripe_charge
                - stripe_invoice
                - netsuite
                - adyen
            - type: 'null'
          title: Payment Provider
          description: >-
            This is used for creating charges or invoices in an external system
            via Orb. When not in test mode, the connection must first be
            configured in the Orb webapp.
        created_at:
          type: string
          format: date-time
          title: Created At
        shipping_address:
          oneOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
        billing_address:
          oneOf:
            - $ref: '#/components/schemas/Address'
            - type: 'null'
        balance:
          type: string
          title: Balance
          description: The customer's current balance in their currency.
        currency:
          oneOf:
            - type: string
            - type: 'null'
          title: Currency
        tax_id:
          oneOf:
            - $ref: '#/components/schemas/CustomerTaxId'
            - type: 'null'
        auto_collection:
          type: boolean
          title: Auto Collection
        exempt_from_automated_tax:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Exempt From Automated Tax
        email_delivery:
          type: boolean
          title: Email Delivery
        auto_issuance:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Auto Issuance
          description: >-
            Whether invoices for this customer should be automatically issued.
            If true, invoices will be automatically issued. If false, invoices
            will require manual approval. If null, inherits the account-level
            setting.
        additional_emails:
          items:
            type: string
          type: array
          title: Additional Emails
        portal_url:
          oneOf:
            - type: string
            - type: 'null'
          title: Portal Url
          description: >-
            Deprecated. Returns the URL of the most recent non-expired portal
            link, or null. When the account has opted into customer portal
            sessions, this field always returns null. Use POST
            /v1/customers/{id}/portal_sessions to mint short-lived portal
            session URLs.
        accounting_sync_configuration:
          oneOf:
            - $ref: '#/components/schemas/AccountingSyncConfiguration'
            - type: 'null'
        reporting_configuration:
          oneOf:
            - $ref: '#/components/schemas/ReportingConfiguration'
            - type: 'null'
        payment_configuration:
          oneOf:
            - $ref: '#/components/schemas/PaymentConfiguration'
            - type: 'null'
          description: >-
            Payment configuration for the customer, applicable when using Orb
            Invoicing with a supported payment provider such as Stripe.
        default_payment_method:
          oneOf:
            - $ref: '#/components/schemas/PaymentMethod'
            - type: 'null'
          description: The customer's default payment method, or null if none is set.
        hierarchy:
          $ref: '#/components/schemas/CustomerHierarchy'
          description: The hierarchical relationships for this customer.
        automatic_tax_enabled:
          oneOf:
            - type: boolean
            - type: 'null'
          title: Automatic Tax Enabled
          description: >-
            Whether automatic tax calculation is enabled for this customer. This
            field is nullable for backwards compatibility but will always return
            a boolean value.
      type: object
      required:
        - metadata
        - id
        - external_customer_id
        - name
        - email
        - timezone
        - payment_provider_id
        - payment_provider
        - created_at
        - shipping_address
        - billing_address
        - balance
        - currency
        - tax_id
        - auto_collection
        - exempt_from_automated_tax
        - email_delivery
        - auto_issuance
        - additional_emails
        - portal_url
        - hierarchy
      title: Customer
      description: >-
        A customer is a buyer of your products, and the other party to the
        billing relationship.


        In Orb, customers are assigned system generated identifiers
        automatically, but it's often desirable to have these

        match existing identifiers in your system. To avoid having to
        denormalize Orb ID information, you can pass in an

        `external_customer_id` with your own identifier. See

        [Customer ID Aliases](/events-and-metrics/customer-aliases) for further
        information about how these

        aliases work in Orb.


        In addition to having an identifier in your system, a customer may exist
        in a payment provider solution like

        Stripe. Use the `payment_provider_id` and the `payment_provider` enum
        field to express this mapping.


        A customer also has a timezone (from the standard [IANA timezone
        database](https://www.iana.org/time-zones)), which

        defaults to your account's timezone. See [Timezone
        localization](/essentials/timezones) for

        information on what this timezone parameter influences within Orb.
    400Error:
      oneOf:
        - $ref: '#/components/schemas/ConstraintViolationError'
        - $ref: '#/components/schemas/DuplicateResourceCreationError'
        - $ref: '#/components/schemas/RequestValidationError'
    401Error:
      $ref: '#/components/schemas/AuthorizationError'
      title: 401Error
    404Error:
      oneOf:
        - $ref: '#/components/schemas/FeatureNotAvailableError'
        - $ref: '#/components/schemas/ResourceNotFoundError'
        - $ref: '#/components/schemas/URLNotFound'
    409Error:
      $ref: '#/components/schemas/IdempotencyRequestMismatch'
      title: 409Error
    413Error:
      oneOf:
        - $ref: '#/components/schemas/RequestTooLargeError'
        - $ref: '#/components/schemas/ResourceTooLargeError'
        - $ref: '#/components/schemas/TooManyResultsError'
    429Error:
      $ref: '#/components/schemas/TooManyRequests'
      title: 429Error
    500Error:
      $ref: '#/components/schemas/ServerError'
      title: 500Error
    Address:
      properties:
        line1:
          oneOf:
            - type: string
            - type: 'null'
          title: Line1
        line2:
          oneOf:
            - type: string
            - type: 'null'
          title: Line2
        city:
          oneOf:
            - type: string
            - type: 'null'
          title: City
        state:
          oneOf:
            - type: string
            - type: 'null'
          title: State
        postal_code:
          oneOf:
            - type: string
            - type: 'null'
          title: Postal Code
        country:
          oneOf:
            - type: string
            - type: 'null'
          title: Country
      type: object
      required:
        - line1
        - line2
        - city
        - state
        - postal_code
        - country
      title: Address
    CustomerTaxId:
      properties:
        country:
          type: string
          enum:
            - AD
            - AE
            - AL
            - AM
            - AO
            - AR
            - AT
            - AU
            - AW
            - AZ
            - BA
            - BB
            - BD
            - BE
            - BF
            - BG
            - BH
            - BJ
            - BO
            - BR
            - BS
            - BY
            - CA
            - CD
            - CH
            - CL
            - CM
            - CN
            - CO
            - CR
            - CV
            - CY
            - CZ
            - DE
            - DK
            - DO
            - EC
            - EE
            - EG
            - ES
            - ET
            - EU
            - FI
            - FO
            - FR
            - GB
            - GE
            - GI
            - GN
            - GR
            - HK
            - HR
            - HU
            - ID
            - IE
            - IL
            - IN
            - IS
            - IT
            - JP
            - KE
            - KG
            - KH
            - KR
            - KZ
            - LA
            - LI
            - LK
            - LT
            - LU
            - LV
            - MA
            - MD
            - ME
            - MK
            - MR
            - MT
            - MX
            - MY
            - NG
            - NL
            - 'NO'
            - NP
            - NZ
            - OM
            - PE
            - PH
            - PL
            - PT
            - PY
            - RO
            - RS
            - RU
            - SA
            - SE
            - SG
            - SI
            - SK
            - SN
            - SR
            - SV
            - TH
            - TJ
            - TR
            - TW
            - TZ
            - UA
            - UG
            - US
            - UY
            - UZ
            - VE
            - VN
            - ZA
            - ZM
            - ZW
          title: Country
        type:
          type: string
          enum:
            - ad_nrt
            - ae_trn
            - al_tin
            - am_tin
            - ao_tin
            - ar_cuit
            - eu_vat
            - au_abn
            - au_arn
            - aw_tin
            - az_tin
            - ba_tin
            - bb_tin
            - bd_bin
            - bf_ifu
            - bg_uic
            - bh_vat
            - bj_ifu
            - bo_tin
            - br_cnpj
            - br_cpf
            - bs_tin
            - by_tin
            - ca_bn
            - ca_gst_hst
            - ca_pst_bc
            - ca_pst_mb
            - ca_pst_sk
            - ca_qst
            - cd_nif
            - ch_uid
            - ch_vat
            - cl_tin
            - cm_niu
            - cn_tin
            - co_nit
            - cr_tin
            - cv_nif
            - de_stn
            - do_rcn
            - ec_ruc
            - eg_tin
            - es_cif
            - et_tin
            - eu_oss_vat
            - fo_vat
            - gb_vat
            - ge_vat
            - gi_tin
            - gn_nif
            - hk_br
            - hr_oib
            - hu_tin
            - id_npwp
            - il_vat
            - in_gst
            - is_vat
            - it_cf
            - jp_cn
            - jp_rn
            - jp_trn
            - ke_pin
            - kg_tin
            - kh_tin
            - kr_brn
            - kz_bin
            - la_tin
            - li_uid
            - li_vat
            - lk_vat
            - ma_vat
            - md_vat
            - me_pib
            - mk_vat
            - mr_nif
            - mx_rfc
            - my_frp
            - my_itn
            - my_sst
            - ng_tin
            - no_vat
            - no_voec
            - np_pan
            - nz_gst
            - om_vat
            - pe_ruc
            - ph_tin
            - pl_nip
            - py_ruc
            - ro_tin
            - rs_pib
            - ru_inn
            - ru_kpp
            - sa_vat
            - sg_gst
            - sg_uen
            - si_tin
            - sn_ninea
            - sr_fin
            - sv_nit
            - th_vat
            - tj_tin
            - tr_tin
            - tw_vat
            - tz_vat
            - ua_vat
            - ug_tin
            - us_ein
            - uy_ruc
            - uz_tin
            - uz_vat
            - ve_rif
            - vn_tin
            - za_vat
            - zm_tin
            - zw_tin
          title: Type
        value:
          type: string
          title: Value
      type: object
      required:
        - country
        - type
        - value
      title: CustomerTaxId
      description: >-
        Tax IDs are commonly required to be displayed on customer invoices,
        which are added to the headers of invoices.



        ### Supported Tax ID Countries and Types



        | Country | Type | Description |

        |---------|------|-------------|

        | Albania | `al_tin` | Albania Tax Identification Number |

        | Andorra | `ad_nrt` | Andorran NRT Number |

        | Angola | `ao_tin` | Angola Tax Identification Number |

        | Argentina | `ar_cuit` | Argentinian Tax ID Number |

        | Armenia | `am_tin` | Armenia Tax Identification Number |

        | Aruba | `aw_tin` | Aruba Tax Identification Number |

        | Australia | `au_abn` | Australian Business Number (AU ABN) |

        | Australia | `au_arn` | Australian Taxation Office Reference Number |

        | Austria | `eu_vat` | European VAT Number |

        | Azerbaijan | `az_tin` | Azerbaijan Tax Identification Number |

        | Bahamas | `bs_tin` | Bahamas Tax Identification Number |

        | Bahrain | `bh_vat` | Bahraini VAT Number |

        | Bangladesh | `bd_bin` | Bangladesh Business Identification Number |

        | Barbados | `bb_tin` | Barbados Tax Identification Number |

        | Belarus | `by_tin` | Belarus TIN Number |

        | Belgium | `eu_vat` | European VAT Number |

        | Benin | `bj_ifu` | Benin Tax Identification Number (Identifiant Fiscal
        Unique) |

        | Bolivia | `bo_tin` | Bolivian Tax ID |

        | Bosnia and Herzegovina | `ba_tin` | Bosnia and Herzegovina Tax
        Identification Number |

        | Brazil | `br_cnpj` | Brazilian CNPJ Number |

        | Brazil | `br_cpf` | Brazilian CPF Number |

        | Bulgaria | `bg_uic` | Bulgaria Unified Identification Code |

        | Bulgaria | `eu_vat` | European VAT Number |

        | Burkina Faso | `bf_ifu` | Burkina Faso Tax Identification Number
        (Numéro d'Identifiant Fiscal Unique) |

        | Cambodia | `kh_tin` | Cambodia Tax Identification Number |

        | Cameroon | `cm_niu` | Cameroon Tax Identification Number (Numéro
        d'Identifiant fiscal Unique) |

        | Canada | `ca_bn` | Canadian BN |

        | Canada | `ca_gst_hst` | Canadian GST/HST Number |

        | Canada | `ca_pst_bc` | Canadian PST Number (British Columbia) |

        | Canada | `ca_pst_mb` | Canadian PST Number (Manitoba) |

        | Canada | `ca_pst_sk` | Canadian PST Number (Saskatchewan) |

        | Canada | `ca_qst` | Canadian QST Number (Québec) |

        | Cape Verde | `cv_nif` | Cape Verde Tax Identification Number (Número
        de Identificação Fiscal) |

        | Chile | `cl_tin` | Chilean TIN |

        | China | `cn_tin` | Chinese Tax ID |

        | Colombia | `co_nit` | Colombian NIT Number |

        | Congo-Kinshasa | `cd_nif` | Congo (DR) Tax Identification Number
        (Número de Identificação Fiscal) |

        | Costa Rica | `cr_tin` | Costa Rican Tax ID |

        | Croatia | `eu_vat` | European VAT Number |

        | Croatia | `hr_oib` | Croatian Personal Identification Number (OIB) |

        | Cyprus | `eu_vat` | European VAT Number |

        | Czech Republic | `eu_vat` | European VAT Number |

        | Denmark | `eu_vat` | European VAT Number |

        | Dominican Republic | `do_rcn` | Dominican RCN Number |

        | Ecuador | `ec_ruc` | Ecuadorian RUC Number |

        | Egypt | `eg_tin` | Egyptian Tax Identification Number |

        | El Salvador | `sv_nit` | El Salvadorian NIT Number |

        | Estonia | `eu_vat` | European VAT Number |

        | Ethiopia | `et_tin` | Ethiopia Tax Identification Number |

        | European Union | `eu_oss_vat` | European One Stop Shop VAT Number for
        non-Union scheme |

        | Faroe Islands | `fo_vat` | Faroe Islands VAT Number |

        | Finland | `eu_vat` | European VAT Number |

        | France | `eu_vat` | European VAT Number |

        | Georgia | `ge_vat` | Georgian VAT |

        | Germany | `de_stn` | German Tax Number (Steuernummer) |

        | Germany | `eu_vat` | European VAT Number |

        | Gibraltar | `gi_tin` | Gibraltar Tax Identification Number |

        | Greece | `eu_vat` | European VAT Number |

        | Guinea | `gn_nif` | Guinea Tax Identification Number (Número de
        Identificação Fiscal) |

        | Hong Kong | `hk_br` | Hong Kong BR Number |

        | Hungary | `eu_vat` | European VAT Number |

        | Hungary | `hu_tin` | Hungary Tax Number (adószám) |

        | Iceland | `is_vat` | Icelandic VAT |

        | India | `in_gst` | Indian GST Number |

        | Indonesia | `id_npwp` | Indonesian NPWP Number |

        | Ireland | `eu_vat` | European VAT Number |

        | Israel | `il_vat` | Israel VAT |

        | Italy | `eu_vat` | European VAT Number |

        | Italy | `it_cf` | Italian Codice Fiscale Number |

        | Japan | `jp_cn` | Japanese Corporate Number (*Hōjin Bangō*) |

        | Japan | `jp_rn` | Japanese Registered Foreign Businesses' Registration
        Number (*Tōroku Kokugai Jigyōsha no Tōroku Bangō*) |

        | Japan | `jp_trn` | Japanese Tax Registration Number (*Tōroku Bangō*) |

        | Kazakhstan | `kz_bin` | Kazakhstani Business Identification Number |

        | Kenya | `ke_pin` | Kenya Revenue Authority Personal Identification
        Number |

        | Kyrgyzstan | `kg_tin` | Kyrgyzstan Tax Identification Number |

        | Laos | `la_tin` | Laos Tax Identification Number |

        | Latvia | `eu_vat` | European VAT Number |

        | Liechtenstein | `li_uid` | Liechtensteinian UID Number |

        | Liechtenstein | `li_vat` | Liechtenstein VAT Number |

        | Lithuania | `eu_vat` | European VAT Number |

        | Luxembourg | `eu_vat` | European VAT Number |

        | Malaysia | `my_frp` | Malaysian FRP Number |

        | Malaysia | `my_itn` | Malaysian ITN |

        | Malaysia | `my_sst` | Malaysian SST Number |

        | Malta | `eu_vat` | European VAT Number |

        | Mauritania | `mr_nif` | Mauritania Tax Identification Number (Número
        de Identificação Fiscal) |

        | Mexico | `mx_rfc` | Mexican RFC Number |

        | Moldova | `md_vat` | Moldova VAT Number |

        | Montenegro | `me_pib` | Montenegro PIB Number |

        | Morocco | `ma_vat` | Morocco VAT Number |

        | Nepal | `np_pan` | Nepal PAN Number |

        | Netherlands | `eu_vat` | European VAT Number |

        | New Zealand | `nz_gst` | New Zealand GST Number |

        | Nigeria | `ng_tin` | Nigerian Tax Identification Number |

        | North Macedonia | `mk_vat` | North Macedonia VAT Number |

        | Northern Ireland | `eu_vat` | Northern Ireland VAT Number |

        | Norway | `no_vat` | Norwegian VAT Number |

        | Norway | `no_voec` | Norwegian VAT on e-commerce Number |

        | Oman | `om_vat` | Omani VAT Number |

        | Paraguay | `py_ruc` | Paraguayan RUC Number |

        | Peru | `pe_ruc` | Peruvian RUC Number |

        | Philippines | `ph_tin` | Philippines Tax Identification Number |

        | Poland | `eu_vat` | European VAT Number |

        | Poland | `pl_nip` | Polish Tax ID Number |

        | Portugal | `eu_vat` | European VAT Number |

        | Romania | `eu_vat` | European VAT Number |

        | Romania | `ro_tin` | Romanian Tax ID Number |

        | Russia | `ru_inn` | Russian INN |

        | Russia | `ru_kpp` | Russian KPP |

        | Saudi Arabia | `sa_vat` | Saudi Arabia VAT |

        | Senegal | `sn_ninea` | Senegal NINEA Number |

        | Serbia | `rs_pib` | Serbian PIB Number |

        | Singapore | `sg_gst` | Singaporean GST |

        | Singapore | `sg_uen` | Singaporean UEN |

        | Slovakia | `eu_vat` | European VAT Number |

        | Slovenia | `eu_vat` | European VAT Number |

        | Slovenia | `si_tin` | Slovenia Tax Number (davčna številka) |

        | South Africa | `za_vat` | South African VAT Number |

        | South Korea | `kr_brn` | Korean BRN |

        | Spain | `es_cif` | Spanish NIF Number (previously Spanish CIF Number)
        |

        | Spain | `eu_vat` | European VAT Number |

        | Sri Lanka | `lk_vat` | Sri Lanka VAT Number |

        | Suriname | `sr_fin` | Suriname FIN Number |

        | Sweden | `eu_vat` | European VAT Number |

        | Switzerland | `ch_uid` | Switzerland UID Number |

        | Switzerland | `ch_vat` | Switzerland VAT Number |

        | Taiwan | `tw_vat` | Taiwanese VAT |

        | Tajikistan | `tj_tin` | Tajikistan Tax Identification Number |

        | Tanzania | `tz_vat` | Tanzania VAT Number |

        | Thailand | `th_vat` | Thai VAT |

        | Turkey | `tr_tin` | Turkish Tax Identification Number |

        | Uganda | `ug_tin` | Uganda Tax Identification Number |

        | Ukraine | `ua_vat` | Ukrainian VAT |

        | United Arab Emirates | `ae_trn` | United Arab Emirates TRN |

        | United Kingdom | `gb_vat` | United Kingdom VAT Number |

        | United States | `us_ein` | United States EIN |

        | Uruguay | `uy_ruc` | Uruguayan RUC Number |

        | Uzbekistan | `uz_tin` | Uzbekistan TIN Number |

        | Uzbekistan | `uz_vat` | Uzbekistan VAT Number |

        | Venezuela | `ve_rif` | Venezuelan RIF Number |

        | Vietnam | `vn_tin` | Vietnamese Tax ID Number |

        | Zambia | `zm_tin` | Zambia Tax Identification Number |

        | Zimbabwe | `zw_tin` | Zimbabwe Tax Identification Number |
    AccountingSyncConfiguration:
      properties:
        excluded:
          type: boolean
          title: Excluded
        accounting_providers:
          items:
            $ref: '#/components/schemas/AccountingProvider'
          type: array
          title: Accounting Providers
      type: object
      required:
        - excluded
        - accounting_providers
      title: AccountingSyncConfiguration
    ReportingConfiguration:
      properties:
        exempt:
          type: boolean
          title: Exempt
      type: object
      required:
        - exempt
      title: ReportingConfiguration
    PaymentConfiguration:
      properties:
        payment_providers:
          items:
            $ref: '#/components/schemas/PaymentConfigurationItem'
          type: array
          title: Payment Providers
          description: Provider-specific payment configuration.
          default: []
      type: object
      title: PaymentConfiguration
    PaymentMethod:
      properties:
        id:
          type: string
          title: Id
          description: The Orb-assigned unique identifier for the payment method.
        payment_method_type:
          type: string
          enum:
            - card
            - us_bank_account
            - link
            - amazon_pay
            - crypto
          title: Payment Method Type
          description: >-
            The type of the underlying payment instrument, e.g. `card` or
            `us_bank_account`.
        provider_type:
          oneOf:
            - type: string
            - type: 'null'
          title: Provider Type
          description: >-
            The external payment provider this method belongs to, derived from
            the linked payment gateway connection (e.g. `adyen` or `stripe`).
            Null if the connection has been removed.
        external_payment_method_id:
          type: string
          title: External Payment Method Id
          description: >-
            The identifier of this payment method in the external payment
            provider.
        customer_id:
          type: string
          title: Customer Id
          description: The ID of the Orb customer this payment method is attached to.
        default:
          type: boolean
          title: Default
          description: Whether this is the customer's default payment method.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The time at which the payment method was created.
      type: object
      required:
        - id
        - payment_method_type
        - provider_type
        - external_payment_method_id
        - customer_id
        - default
        - created_at
      title: PaymentMethod
      description: >-
        A payment method represents a customer's stored payment instrument held
        with an external payment

        provider (such as Adyen or Stripe).


        The serialization is intentionally minimal for now; provider-pulled
        details (e.g. card display

        metadata) will be added over time.
    CustomerHierarchy:
      properties:
        parent:
          oneOf:
            - $ref: '#/components/schemas/CustomerMinified'
            - type: 'null'
        children:
          items:
            $ref: '#/components/schemas/CustomerMinified'
          type: array
          title: Children
      type: object
      required:
        - parent
        - children
      title: CustomerHierarchy
    ConstraintViolationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-constraint-violation
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ConstraintViolationError
    DuplicateResourceCreationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-duplicate-resource-creation
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: DuplicateResourceCreationError
    RequestValidationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#400-request-validation-errors
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
        validation_errors:
          items: {}
          type: array
          title: Validation Errors
      type: object
      required:
        - type
        - status
        - validation_errors
      title: RequestValidationError
    AuthorizationError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#401-authentication-error
          title: Type
        status:
          type: integer
          enum:
            - 401
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: AuthorizationError
    FeatureNotAvailableError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-feature-not-available
          title: Type
        status:
          type: integer
          enum:
            - 400
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: FeatureNotAvailableError
    ResourceNotFoundError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-resource-not-found
          title: Type
        status:
          type: integer
          enum:
            - 404
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          type: string
          title: Title
      type: object
      required:
        - type
        - status
        - title
      title: ResourceNotFoundError
    URLNotFound:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#404-url-not-found
          title: Type
        status:
          type: integer
          enum:
            - 404
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: URLNotFound
    IdempotencyRequestMismatch:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#409-resource-conflict
          title: Type
        status:
          type: integer
          enum:
            - 409
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: IdempotencyRequestMismatch
    RequestTooLargeError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-request-too-large
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: RequestTooLargeError
    ResourceTooLargeError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-resource-too-large
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ResourceTooLargeError
    TooManyResultsError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#413-too-many-results
          title: Type
        status:
          type: integer
          enum:
            - 413
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: TooManyResultsError
    TooManyRequests:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#429-too-many-requests
          title: Type
        status:
          type: integer
          enum:
            - 429
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: TooManyRequests
    ServerError:
      properties:
        type:
          type: string
          enum:
            - >-
              https://docs.withorb.com/reference/error-responses#500-internal-server-error
          title: Type
        status:
          type: integer
          title: Status
        detail:
          oneOf:
            - type: string
            - type: 'null'
          title: Detail
        title:
          oneOf:
            - type: string
            - type: 'null'
          title: Title
      type: object
      required:
        - type
        - status
      title: ServerError
    AccountingProvider:
      properties:
        provider_type:
          type: string
          enum:
            - quickbooks
            - netsuite
          title: Provider Type
        external_provider_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Provider Id
      type: object
      required:
        - provider_type
        - external_provider_id
      title: AccountingProvider
    PaymentConfigurationItem:
      properties:
        provider_type:
          type: string
          enum:
            - stripe
          title: Provider Type
          description: The payment provider to configure.
        excluded_payment_method_types:
          items:
            type: string
          type: array
          title: Excluded Payment Method Types
          description: >-
            List of Stripe payment method types to exclude for this customer.
            Excluded payment methods will not be available for the customer to
            select during payment, and will not be used for auto-collection. If
            a customer's default payment method becomes excluded, Orb will
            attempt to use the next available compatible payment method for
            auto-collection.
          default: []
        default_shared_payment_token:
          oneOf:
            - type: string
            - type: 'null'
          title: Default Shared Payment Token
          description: >-
            The ID of a shared payment token granted by an agent to use as the
            default payment instrument for this customer. When set,
            auto-collection will use this token instead of the customer's
            default payment method.
      type: object
      required:
        - provider_type
      title: PaymentConfigurationItem
    CustomerMinified:
      properties:
        id:
          type: string
          title: Id
        external_customer_id:
          oneOf:
            - type: string
            - type: 'null'
          title: External Customer Id
      type: object
      required:
        - id
        - external_customer_id
      title: CustomerMinified
  securitySchemes:
    APIKeyAuth:
      type: http
      description: API Keys can be issued in the Orb's web application.
      scheme: bearer

````